/*
 *  Copyright (c) 2010 Cyrille Berger <cberger@cberger.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _CAUCHY_OPTIONS_H_
#define _CAUCHY_OPTIONS_H_

namespace Cauchy {
  class String;
  class Options {
    public:
      Options();
      Options(const Options&);
      Options& operator=(const Options&);
      ~Options();
      void setOption(const String& name, const String& value);
      bool hasOption(const String& name) const;
      String option(const String& name) const;
    private:
      inline void deref();
      struct Private;
      Private* d;
  };
}

#endif
